/**********************************************************************
 * Copyright (c) 2003 Hyades project.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Common Public License v0.5
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v05.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.internal.execution.local.control;

public class ProcessFactory {
	
	
	public static Process createProcess(Node node) {
		Process process=new ProcessImpl(node);
		if(node instanceof NodeImpl) {
			process.addProcessListener(((NodeImpl)node).getProcessListener());
		}
		return process;
	}
	
	public static Process createProcess(Node node, String executable) {
		Process process=new ProcessImpl(node, executable);
		if(node instanceof NodeImpl) {
			process.addProcessListener(((NodeImpl)node).getProcessListener());
		}
		return process;
	}
	
	public static Process createProcess(Node node, String executable, String parameters) {
		Process process=new ProcessImpl(node, executable, parameters);
		if(node instanceof NodeImpl) {
			process.addProcessListener(((NodeImpl)node).getProcessListener());
		}
		return process;
	}
}

